package net.minecraft.src;

import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import net.minecraft.server.MinecraftServer;

// TODO Entities aren't being sent to client
// TODO Parachute not working
// TODO Sentries don't show up, just generally fucked

// TODO Grappling hook goes black when mining in multiplayer, same with oil
// TODO Gunshots not heard

// TODO First nade doesn't reduce count
// TODO Double nades/rockets/stuff
// TODO No sound picking up casings
// TODO Parachute wrong skin
// TODO Flame starts sideways/backwards, fix with a small initial velocity?
// TODO Grenade differences could be caused by height difference
// TODO Handle recoil spread

// TODO Scoring
// TODO Option to not drop guns/only drop selected?
// TODO Minimap with teammates on it
// TODO Respawn with weapon, set ID
// TODO Have option that mouse wheel scroll doesn't go to empty space?

// TODO Server spawn isn't safe, doesn't check for blocks in the way
// TODO Nether spawn locations

// TODO Add better error handling in ModLoader.ThrowException(String, Throwable)

// SDK
@SuppressWarnings({ "rawtypes", "unchecked" })
public class mod_SdkGuns extends SdkBaseModMultiplayer
{
    public static final Block blockNuke = (new SdkBlockNuke(110, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(0.0F).setStepSound(Block.soundGrassFootstep).setBlockName("nuke");
    public static final Block blockSentry = (new SdkBlockSentry(111, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setBlockName("sentry");
    public static final Block blockLighter = (new SdkBlockLighter(112, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("lighter");
    public static int blockLighterSideIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png");
    public static final Block blockOil = (new SdkBlockOil(113, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"), ModLoader.getUniqueBlockModelID(null, false))).setHardness(-1F).setBlockName("blockOil");
    public static final int blockOilLineIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png");
    public static final Block blockCannon = (new SdkBlockCannon(114, ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png"))).setHardness(3.5F).setStepSound(Block.soundStoneFootstep).setBlockName("cannon");
	
	public static final Item itemBulletCasing = (new Item(2500)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasing.png")).setItemName("bulletCasing");
    public static final Item itemBulletLight = (new SdkItemCustomStackSize(2501, 32)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet9mm.png")).setItemName("bullet9mm");
    public static final Item itemBulletMedium = (new SdkItemCustomStackSize(2502, 8)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet357.png")).setItemName("bullet357");
    public static final Item itemBulletShell = (new SdkItemCustomStackSize(2503, 8)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletShell.png")).setItemName("bulletShell");
    public static final Item itemGunAk47 = (new SdkItemGunAk47(2504)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunAk47.png")).setItemName("gunAk47");
    public static final Item itemGunMp5 = (new SdkItemGunMp5(2505)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunMp5.png")).setItemName("gunMp5");
    public static final Item itemGunShotgun = (new SdkItemGunShotgun(2506)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunShotgun.png")).setItemName("gunShotgun");
    public static final Item itemGunDeagle = (new SdkItemGunDeagle(2507)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunDeagle.png")).setItemName("gunDeagle");
    public static final Item itemGrenade = (new SdkItemGrenade(2508, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenade.png")).setItemName("grenade");
    public static final Item itemMetalParts = (new Item(2514)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemMetalParts.png")).setItemName("metalParts");
    public static final Item itemBulletRocket = (new SdkItemCustomStackSize(2515, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocket.png")).setItemName("bulletRocket");
    public static final Item itemGunRocketLauncher = (new SdkItemGunRocketLauncher(2516)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncher.png")).setItemName("gunRocketLauncher");
    public static final Item itemBulletRocketLaser = (new SdkItemCustomStackSize(2517, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletRocketLaser.png")).setItemName("bulletRocketLaser");
    public static final Item itemGunRocketLauncherLaser = (new SdkItemGunRocketLauncherLaser(2518)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunRocketLauncherLaser.png")).setItemName("gunRocketLauncherLaser");
    public static final Item itemBulletHeavy = (new SdkItemCustomStackSize(2519, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBullet50Cal.png")).setItemName("bullet50Cal");
    public static final Item itemGunSniper = (new SdkItemGunSniper(2520)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSniper.png")).setItemName("gunSniper");
    public static final Item itemGrenadeStun = (new SdkItemGrenadeStun(2522, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeStun.png")).setItemName("grenadeStun");
    public static final Item itemGrenadeSmoke = (new SdkItemGrenadeSmoke(2524, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSmoke.png")).setItemName("grenadeSmoke");
    public static final Item itemBulletCasingShell = (new Item(2525)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemBulletCasingShell.png")).setItemName("bulletCasingShell");
    public static final Item itemOil = (new SdkItemOil(2526)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemOil.png")).setItemName("itemOil");
    public static final Item itemGunFlamethrower = (new SdkItemGunFlamethrower(2527)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunFlamethrower.png")).setItemName("gunFlamethrower");
    public static final Item itemGrenadeSticky = (new SdkItemGrenadeSticky(2530, 4)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGrenadeSticky.png")).setItemName("grenadeSticky");
    public static final Item itemGunSg552 = (new SdkItemGunSg552(2531)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunSg552.png")).setItemName("gunSg552");
    public static final Item itemGunGatling = (new SdkItemGunGatling(2532)).setIconIndex(ModLoader.addOverride("/gui/items.png", "/sdk/itemGunGatling.png")).setItemName("gunGatling");

    // Sentry texture indices
    public static Class[] sentryEntityClasses = { SdkEntitySentryAk47.class, SdkEntitySentryMp5.class, SdkEntitySentryShotgun.class, SdkEntitySentryDeagle.class,
    	SdkEntitySentryRocketLauncher.class, SdkEntitySentryRocketLauncherLaser.class, SdkEntitySentrySniper.class, SdkEntitySentryFlamethrower.class, SdkEntitySentrySg552.class };
    public static int[] sentryTextureIndices = {
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryAk47.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryMp5.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryShotgun.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryDeagle.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncher.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryRocketLauncherLaser.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentrySniper.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentryFlamethrower.png"),
    	ModLoader.addOverride("/terrain.png", "/sdk/blockSentrySg552.png")
    };
    
    // For multiple textures
    public static final int blockSentrySideIndexInTexture = ModLoader.addOverride("/terrain.png", "/sdk/blockNuke.png");
    
    // Instead of in EntityPlayer
    public static Map<EntityPlayer, Integer> reloadTimes = new HashMap<EntityPlayer, Integer>();
    public static final double RECOIL_FIX_FACTOR = 0.1F;
    public static double currentRecoilV = 0F;
    public static double currentRecoilH = 0F;
    public static Map<EntityLiving, Pair<Integer, Float>> flashTimes = new HashMap<EntityLiving, Pair<Integer, Float>>();
    
    // Properties
    public static boolean guns = true;
    public static boolean bulletsDestroyGlass = true;
    public static boolean grenades = true;
    public static boolean grenadesDestroyBlocks = false;
    public static boolean nuke = true;
    public static float nukeBlastDiameter = 8;
    public static int nukeFuse = 80;
    public static boolean oil = true;
    public static boolean lighter = true;
    public static boolean cannon = true;
    public static boolean sentries = false;
    public static boolean sentriesKillAnimals = false;
    public static boolean ammoRestrictions = true;
    public static boolean hardcore = false;
    public static boolean ammoCasings = true;
	
    // For zoom
	private static Map<EntityPlayer, Boolean> isSniperZoomedin = new HashMap<EntityPlayer, Boolean>();

    static
    {
    	loadProperties();
        setHardcore();
    }
    
    private static void loadProperties()
    {
    	Properties properties = new Properties();
    	try
    	{
    		String propertiesPath = mod_SdkGuns.class.getProtectionDomain().getCodeSource().getLocation().toURI().getPath();
    		propertiesPath = propertiesPath.substring(0, propertiesPath.lastIndexOf('/') + 1);
    		propertiesPath += "mod_SdkGuns.properties";
    		
    		properties.load(new FileInputStream(propertiesPath));
    		String property;
    		
    		property = properties.getProperty("guns");
    		guns = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("bulletsDestroyGlass");
    		bulletsDestroyGlass = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenades");
    		grenades = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("grenadesDestroyBlocks");
    		grenadesDestroyBlocks = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("nuke");
    		nuke = property.trim().equalsIgnoreCase("true");

    		property = properties.getProperty("nukeBlastDiameter");
    		nukeBlastDiameter = Float.parseFloat(property.trim());

    		property = properties.getProperty("nukeFuse");
    		nukeFuse = Integer.parseInt(property.trim());
    		
    		property = properties.getProperty("oil");
    		oil = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("lighter");
    		lighter = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("cannon");
    		cannon = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentries");
    		sentries = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("sentriesKillAnimals");
    		sentriesKillAnimals = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoRestrictions");
    		ammoRestrictions = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("hardcore");
    		hardcore = property.trim().equalsIgnoreCase("true");
    		
    		property = properties.getProperty("ammoCasings");
    		ammoCasings = property.trim().equalsIgnoreCase("true");
        }
        catch(Exception e)
        {
        	System.out.println("Error loading properties.");
			e.printStackTrace();
        }
    }

	private static void setHardcore()
    {
    	try
		{
    		Field[] fields = EnumCreatureType.class.getDeclaredFields();
			for(int i = 0; i < fields.length; i++)
				if(fields[i].getType() == int.class)
				{
					fields[i].setAccessible(true);
					
					Field modifiersField = Field.class.getDeclaredField("modifiers");
				    modifiersField.setAccessible(true);
				    modifiersField.setInt(fields[i], fields[i].getModifiers() & ~Modifier.FINAL);
					
				    int numMobs, numWaterMobs;
				    if(hardcore)
				    {
				    	numMobs = 700;
				    	numWaterMobs = 50;
				    }
				    else
				    {
				    	numMobs = 70;
				    	numWaterMobs = 5;
				    }
				    
				    fields[i].set(EnumCreatureType.monster, numMobs);
				    fields[i].set(EnumCreatureType.waterCreature, numWaterMobs);
				}
		}
		catch (Exception e)
		{
			System.out.println("Error setting hardcore mode: " + hardcore);
			e.printStackTrace();
		}
    }
	
	public mod_SdkGuns()
	{
		super();
		
		ModLoader.RegisterBlock(blockNuke);
		ModLoader.RegisterBlock(blockSentry, SdkItemSentry.class);
		ModLoader.RegisterBlock(blockLighter);
		ModLoader.RegisterBlock(blockOil);
		ModLoader.RegisterBlock(blockCannon);
		
		setBurnRates();
	    
	    // For showing ammo amount
	    itemBulletLight.maxDamage = 0;
	    itemBulletMedium.maxDamage = 0;
	    itemBulletShell.maxDamage = 0;
	    itemBulletRocket.maxDamage = 0;
	    itemBulletRocketLaser.maxDamage = 0;
	    itemBulletHeavy.maxDamage = 0;
		
		ModLoader.RegisterEntityID(SdkEntityBullet.class, "Bullet", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletShot.class, "Shell", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasing.class, "Casing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletCasingShell.class, "ShellCasing", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenade.class, "Grenade", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityNukePrimed.class, "Nuke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryAk47.class, "SentryAk47", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryDeagle.class, "SentryDeagle", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryMp5.class, "SentryMp5", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncher.class, "SentryRocketLauncher", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryRocketLauncherLaser.class, "SentryRocketLauncherLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryShotgun.class, "SentryShotgun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySniper.class, "SentrySniper", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocket.class, "Rocket", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletRocketLaser.class, "RocketLaser", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeStun.class, "GrenadeStun", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSmoke.class, "GrenadeSmoke", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityBulletFlame.class, "Flame", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentryFlamethrower.class, "SentryFlamethrower", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntityGrenadeSticky.class, "GrenadeSticky", ModLoader.getUniqueEntityId());
		ModLoader.RegisterEntityID(SdkEntitySentrySg552.class, "SentrySg552", ModLoader.getUniqueEntityId());
	}

	public static void setBurnRates()
	{
		//SdkTools.setBurnRate(blockNuke.blockID, 15, 100);
		SdkTools.setBurnRate(blockOil.blockID, 30, 60);
	}
	
	@Override
	public String Version()
	{
		return "1.3_01v4";
	}

	@Override
	public void SetRecipes(CraftingManager craftingmanager) {
    	itemBulletLight.maxStackSize = 32;
    	itemBulletMedium.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemBulletShell.maxStackSize = ammoRestrictions ? 8 : 32;
    	itemGrenade.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemBulletRocket.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletRocketLaser.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemBulletHeavy.maxStackSize = ammoRestrictions ? 4 : 32;
    	itemGrenadeStun.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSmoke.maxStackSize = ammoRestrictions ? 4 : 64;
    	itemGrenadeSticky.maxStackSize = ammoRestrictions ? 4 : 64;
		
		SdkTools.setShapedRecipe(craftingmanager, nuke, new ItemStack(blockNuke, 1), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Block.tnt, Character.valueOf('#'), Item.redstone
        });
		
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunAk47, 1), new Object[] {
            "X  ", "XX ", " X#", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunMp5, 1), new Object[] {
        	"X  ", "XX ", " XX", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunDeagle, 1), new Object[] {
        	"XXX", "  X", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunShotgun, 1), new Object[] {
        	"X  ", "#X ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Block.wood
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasing
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletLight, itemBulletLight.maxStackSize), new Object[] {
            "X", "#", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletMedium, itemBulletMedium.maxStackSize), new Object[] {
            "X ", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletShell, itemBulletShell.maxStackSize), new Object[] {
            "X ", "#Y", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder, Character.valueOf('Y'), Item.paper
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncher, 1), new Object[] {
            "XXX", "XX ", Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunRocketLauncherLaser, 1), new Object[] {
            "#XY", Character.valueOf('#'), Item.diamond, Character.valueOf('X'), itemMetalParts, Character.valueOf('Y'), itemGunRocketLauncher
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletRocket, itemBulletRocket.maxStackSize), new Object[] {
            "###", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletRocketLaser, itemBulletRocketLaser.maxStackSize), new Object[] {
            "#Y#", "#X#", "XXX", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron,  Character.valueOf('Y'), Item.redstone
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSniper, 1), new Object[] {
            "X  ", " X#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemBulletHeavy, itemBulletHeavy.maxStackSize), new Object[] {
            "XX", "##", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.gunpowder
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(Item.ingotIron, 1), new Object[] {
        	"XX", "XX", Character.valueOf('X'), itemBulletCasingShell
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunFlamethrower, 1), new Object[] {
			"X# ", "XX ", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.flintAndSteel
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunSg552, 1), new Object[] {
			"X  ", "XX#", " XX", Character.valueOf('X'), itemMetalParts, Character.valueOf('#'), Item.diamond
        });
		SdkTools.setShapedRecipe(craftingmanager, guns, new ItemStack(itemGunGatling, 1), new Object[] {
			"XX ", "XXX", " XX", Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, guns || sentries, new ItemStack(itemMetalParts, 1), new Object[] {
			"##", "##", Character.valueOf('#'), Item.ingotIron
		});
		SdkTools.setShapedRecipe(craftingmanager, guns || sentries, new ItemStack(Item.ingotIron, 4), new Object[] {
			"#", Character.valueOf('#'), itemMetalParts
		});
		
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenade, 4), new Object[] {
            "X#X", "#X#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron
        });
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeStun, 4), new Object[] {
            "X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.lightStoneDust
        });
		SdkTools.setShapedRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeSmoke, 4), new Object[] {
			"X#X", "#Y#", "X#X", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.ingotIron, Character.valueOf('Y'), Item.flint
        });
		SdkTools.setShapelessRecipe(craftingmanager, grenades, new ItemStack(itemGrenadeSticky), new Object[] {
            new ItemStack(itemGrenade), new ItemStack(Item.slimeBall)
        });
		
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 0), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunAk47, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 1), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunMp5, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 2), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunShotgun, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 3), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunDeagle, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 4), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncher, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 5), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunRocketLauncherLaser, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 6), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSniper, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 7), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunFlamethrower, Character.valueOf('X'), itemMetalParts
        });
		SdkTools.setShapedRecipe(craftingmanager, sentries && guns, new ItemStack(blockSentry, 1, 8), new Object[] {
        	" # ", " X ", "X X", Character.valueOf('#'), itemGunSg552, Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, sentries && !guns, new ItemStack(blockSentry, 1, 0), new Object[] {
        	" X ", " X ", "X X", Character.valueOf('X'), itemMetalParts
        });
		
		SdkTools.setShapedRecipe(craftingmanager, lighter, new ItemStack(blockLighter, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Block.cobblestone, Character.valueOf('#'), Item.flintAndSteel
        });
	
		SdkTools.setShapedRecipe(craftingmanager, oil, new ItemStack(itemOil, 1), new Object[] {
        	" X ", "X#X", " X ", Character.valueOf('X'), Item.gunpowder, Character.valueOf('#'), Item.bucketWater
        });
		
		SdkTools.setShapedRecipe(craftingmanager, cannon, new ItemStack(blockCannon, 1), new Object[] {
        	"XXX", "X#X", "XXX", Character.valueOf('X'), Item.ingotIron, Character.valueOf('#'), Item.redstone
        });
	}
	
	@Override
	public void AddEntityTrackers(Map<Class, Pair<Integer, Integer>> map)
	{
		map.put(SdkEntityBullet.class, new Pair<Integer, Integer>(64, 5));
		map.put(SdkEntityBulletCasing.class, new Pair<Integer, Integer>(64, 5));
		map.put(SdkEntityNukePrimed.class, new Pair<Integer, Integer>(160, 10));
		map.put(SdkEntitySentry.class, new Pair<Integer, Integer>(160, 3));
	}
	
	@Override
	public void AddEntityTrackerEntries(Map<Class, Integer> map)
	{
		map.put(SdkEntityBullet.class, 100);
		map.put(SdkEntityBulletShot.class, 101);
		map.put(SdkEntityBulletCasing.class, 102);
		map.put(SdkEntityBulletCasingShell.class, 103);
		map.put(SdkEntityGrenade.class, 104);
		map.put(SdkEntityNukePrimed.class, 105);
		map.put(SdkEntitySentryAk47.class, 106);
		map.put(SdkEntitySentryDeagle.class, 107);
		map.put(SdkEntitySentryMp5.class, 108);
		map.put(SdkEntitySentryRocketLauncher.class, 109);
		map.put(SdkEntitySentryRocketLauncherLaser.class, 110);
		map.put(SdkEntitySentryShotgun.class, 111);
		map.put(SdkEntitySentrySniper.class, 112);
		map.put(SdkEntityBulletRocket.class, 113);
		map.put(SdkEntityBulletRocketLaser.class, 114);
		map.put(SdkEntityGrenadeStun.class, 115);
		map.put(SdkEntityGrenadeSmoke.class, 116);
		map.put(SdkEntityBulletFlame.class, 117);
		map.put(SdkEntitySentryFlamethrower.class, 118);
		map.put(SdkEntityGrenadeSticky.class, 121);
		map.put(SdkEntitySentrySg552.class, 122);
	}
	
	@Override
	public void OnTickInGameTick(MinecraftServer minecraftServer)
	{
        // Handle reload
		handleReload();
		
		// Handle flash
		handleFlash();
	}

	private void handleReload() {
		Iterator<Map.Entry<EntityPlayer,Integer>> it = reloadTimes.entrySet().iterator();
    	while (it.hasNext()) {
    	    Map.Entry<EntityPlayer,Integer> entry = it.next();
    	    
    	    int n = entry.getValue() - 1;
    	    
    	    if (n <= 0)
    	        it.remove();
    	    else
    	    	entry.setValue(n);
    	}
	}

	private void handleFlash() {
		Iterator<Map.Entry<EntityLiving,Pair<Integer, Float>>> it = flashTimes.entrySet().iterator();
    	while (it.hasNext())
    	{
    	    Map.Entry<EntityLiving,Pair<Integer, Float>> entry = it.next();
    	    
    	    int n = entry.getValue().getLeft() - 1;
    	    
    	    if (n <= 0)
    	    {
    	    	entry.getKey().moveSpeed = entry.getValue().getRight();
    	        it.remove();
    	    }
    	    else
    	    {
    	    	entry.setValue(new Pair<Integer, Float>(n, entry.getValue().getRight()));
    	    }
    	}
	}
	
	@Override
	public void HandlePacket(Packet200ModLoader packet200ModLoader, EntityPlayerMP entityPlayerMp)
	{
		switch(packet200ModLoader.packetType)
		{
			case 0:
			{
				if(packet200ModLoader.dataInt[0] == 0)
				{
					isSniperZoomedin.put(entityPlayerMp, false);
				}
				else if(packet200ModLoader.dataInt[0] == 1)
				{
					isSniperZoomedin.put(entityPlayerMp, true);
				}
			}
		}
	}

	public static void handleReload(World world, EntityPlayer entityPlayer, boolean forcedReload)
	{
		if(!reloadTimes.containsKey(entityPlayer))
		{
			ItemStack itemStack = entityPlayer.getCurrentEquippedItem();
			if(itemStack != null && itemStack.getItem() instanceof SdkItemGun)
			{
				Item ammo = ((SdkItemGun)itemStack.getItem()).requiredBullet;
	
				int firstIndex = -1;
				int firstAmmoAmount = -1, secondAmmoAmount = -1;
				boolean hasReloaded = false;
				do
				{
					secondAmmoAmount = -1;
					
					InventoryPlayer inventory = entityPlayer.inventory;
					for(int j = firstIndex + 1; j < inventory.mainInventory.length; j++)
			            if(inventory.mainInventory[j] != null && inventory.mainInventory[j].itemID == ammo.shiftedIndex)
			            {
			            	if(ammo.maxDamage > 0)
			            	{
			            		int fullAmmoCount = ammo.maxDamage + 1;
			            		
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = fullAmmoCount - getItemDamage(inventory.mainInventory[j]);
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.maxDamage > 0 && firstAmmoAmount == ammo.maxDamage + 1)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = fullAmmoCount - getItemDamage(inventory.mainInventory[j]);
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(fullAmmoCount - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			setItemDamage(inventory.mainInventory[firstIndex], fullAmmoCount - firstAmmoAmount);
			            			setItemDamage(inventory.mainInventory[j], fullAmmoCount - secondAmmoAmount);
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = new ItemStack(Item.bucketEmpty);
		            				
		            				break;
			            		}
			            	}
			            	else
			            	{
			            		if(firstIndex == -1)
			            		{
			            			// Get size of first stack
			            			firstAmmoAmount = inventory.mainInventory[j].stackSize;
			    					
			    					// Break if full
			    					if(!forcedReload && ammo.maxDamage == 0 && firstAmmoAmount == ammo.maxStackSize)
			    						break;
			            		}
			            		else
			            		{
			            			// Reload
			            			if(!hasReloaded)
			            			{
			            				reload(world, entityPlayer);
			            				hasReloaded = true;
			            			}
			            			
			            			// Get size of second stack
			            			secondAmmoAmount = inventory.mainInventory[j].stackSize;
			            			
			            			// Find out how much ammo to shift
			            			int ammoToShift = Math.min(ammo.maxStackSize - firstAmmoAmount, secondAmmoAmount);
			            			
			            			// Shift ammo
			            			firstAmmoAmount += ammoToShift;
			            			secondAmmoAmount -= ammoToShift;
			            			inventory.mainInventory[firstIndex].stackSize = firstAmmoAmount;
		            				inventory.mainInventory[j].stackSize = secondAmmoAmount;
		            				
		            				// Nullify empty stack
		            				if(secondAmmoAmount == 0)
		            					inventory.mainInventory[j] = null;
		            				
		            				break;
			            		}
			            	}
			            	
			            	if(firstIndex == -1)
			            		firstIndex = j;
			            }
					
					// Break if no ammo found
					if(firstIndex == -1)
						break;
					
					// Reload and break if forced
					if(!hasReloaded && forcedReload)
					{
						reload(world, entityPlayer);
						break;
					}
					
					// Break if only one ammo stack found
					if(secondAmmoAmount == -1)
						break;
					
					// Break if full
					if(ammo.maxDamage == 0 && firstAmmoAmount == ammo.maxStackSize)
						break;
					
					// Break if full
					if(ammo.maxDamage > 0 && firstAmmoAmount == ammo.maxDamage + 1)
						break;
				}
				while(true);
			}
		}
	}
	
	public static void reload(World world, EntityPlayer entityplayer)
	{
		world.playSoundAtEntity(entityplayer, "sdk.reload", 1.0F, 1.0F / (entityplayer.rand.nextFloat() * 0.1F + 0.95F));
		reloadTimes.put(entityplayer, 40);
	}
	
	@Override
	public void HandleLogin(EntityPlayerMP entityPlayerMp)
	{
		sendProperties(entityPlayerMp);
	}

	private void sendProperties(EntityPlayerMP entityPlayerMp)
	{
		int[] dataInt = new int[13];
		dataInt[0] = guns ? 1 : 0;
		dataInt[1] = bulletsDestroyGlass ? 1 : 0;
		dataInt[2] = grenades ? 1 : 0;
		dataInt[3] = grenadesDestroyBlocks ? 1 : 0;
		dataInt[4] = nuke ? 1 : 0;
		dataInt[5] = nukeFuse;
		dataInt[6] = oil ? 1 : 0;
		dataInt[7] = lighter ? 1 : 0;
		dataInt[8] = cannon ? 1 : 0;
		dataInt[9] = sentries ? 1 : 0;
		dataInt[10] = sentriesKillAnimals ? 1 : 0;
		dataInt[11] = ammoRestrictions ? 1 : 0;
		dataInt[12] = hardcore ? 1 : 0;
		
		float[] dataFloat = new float[1];
		dataFloat[0] = nukeBlastDiameter;
		
		Packet200ModLoader packet200ModLoader = new Packet200ModLoader();
		packet200ModLoader.packetType = 1;
		packet200ModLoader.dataInt = dataInt;
		packet200ModLoader.dataFloat = dataFloat;
		ModLoaderMp.SendPacketTo(this, entityPlayerMp, packet200ModLoader);
	}

	public static boolean getSniperZoomedIn(EntityPlayer entityPlayer)
	{
		Boolean isSniperZoomedInBoolean = isSniperZoomedin.get(entityPlayer);
		
		return isSniperZoomedInBoolean == null ? false : isSniperZoomedInBoolean;
	}
	
	public static int getItemDamage(ItemStack itemStack)
	{
		try
		{
			return (Integer)ModLoader.getPrivateValue(ItemStack.class, itemStack, 3);
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error getting item damage.");
		}
		
		return 0;
	}
	
	public static void setItemDamage(ItemStack itemStack, int itemDamage)
	{
		try
		{
			ModLoader.setPrivateValue(ItemStack.class, itemStack, 3, itemDamage);
		}
		catch (NoSuchFieldException ex)
		{
			System.out.println("Error setting item damage.");
		}
	}
	
	public static boolean playerInventoryEmpty(InventoryPlayer inventory)
    {
        for(int j = 0; j < inventory.mainInventory.length; j++)
        {
            if(inventory.mainInventory[j] != null)
            {
            	return false;
            }
        }
        
        for(int j = 0; j < inventory.armorInventory.length; j++)
        {
            if(inventory.armorInventory[j] != null)
            {
            	return false;
            }
        }
        
        return true;
    }

	@Override
	public void OnMainMenu() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void InitBlocks() {
		// TODO Auto-generated method stub
		
	}
}
